public class UE20Aufgabe23 {
	public static void main(String[] args) {
		final int anzahlReihen = 3;
		final int anzahlSpalten = 5;
		Spieler spieler1 = new Mensch();
		Spieler spieler2 = new Computer();
		Chomp chomp = new Chomp(anzahlReihen, anzahlSpalten, spieler1, spieler2);
		chomp.spielen();
	}
}

class Chomp {

	Spieler[] spieler;
	boolean[][] schokolade;

	public Chomp(int anzahlReihen, int anzahlSpalten, Spieler spieler1,
			Spieler spieler2) {
		this.spieler = new Spieler[2];
		this.spieler[0] = spieler1;
		this.spieler[1] = spieler2;
		this.schokolade = new boolean[anzahlReihen][anzahlSpalten];
		for (int r = 0; r < anzahlReihen; r++) {
			for (int s = 0; s < anzahlSpalten; s++) {
				this.schokolade[r][s] = true;
			}
		}
	}

	public void spielen() {
		int aktuellerSpieler = 0;
		this.spielfeldAusgeben();
		while (true) {
			System.out.println("Spieler " + (aktuellerSpieler + 1)
					+ " ist am Zug!");
			Spielzug zug = null;
			try {
				zug = this.spieler[aktuellerSpieler]
						.naechsterSpielzug(this.schokolade);
			} catch (Throwable exc) {
				System.out.println("Fehlerhafte Spielzugermittlung! Spieler "
						+ (aktuellerSpieler + 1) + " hat verloren!");
				break;
			}

			System.out.println(zug);

			if (!this.istOk(zug)) {
				System.out.println("Ungueltiger Spielzug! Spieler "
						+ (aktuellerSpieler + 1) + " hat verloren!");
				break;
			}

			this.ausfuehren(zug);

			if (this.ende()) {
				System.out.println("Bauchschmerzen! Spieler "
						+ (aktuellerSpieler + 1) + " hat verloren!");
				break;
			}
			this.spielfeldAusgeben();
			aktuellerSpieler = (aktuellerSpieler + 1) % 2; // Spielerwechsel
		}
	}

	boolean istOk(Spielzug zug) {
		int r = zug.getReihe();
		int s = zug.getSpalte();

		return r >= 0 && r < this.schokolade.length && s >= 0
				&& s < this.schokolade[0].length && this.schokolade[r][s];

		// eigentlich muesste auch noch ueberprueft werden, ob die
		// boolean-Matrix manipuliert wurde; war aber nicht verlangt!
	}

	void ausfuehren(Spielzug zug) {
		for (int r = zug.getReihe(); r < this.schokolade.length; r++) {
			for (int s = zug.getSpalte(); s < this.schokolade[0].length; s++) {
				this.schokolade[r][s] = false;
			}
		}
	}

	boolean ende() {
		return !this.schokolade[0][0];
	}

	void spielfeldAusgeben() {
		for (int r = 0; r < this.schokolade.length; r++) {
			for (int s = 0; s < this.schokolade[0].length; s++) {
				if (this.schokolade[r][s]) {
					System.out.print("T");
				}
			}
			System.out.println();
		}
	}

}

class Spielzug {
	private int reihe;
	private int spalte;

	public Spielzug(int reihe, int spalte) {
		this.reihe = reihe;
		this.spalte = spalte;
	}

	public int getReihe() {
		return this.reihe;
	}

	public int getSpalte() {
		return this.spalte;
	}

	@Override
	public String toString() {
		return "Zug: r=" + this.reihe + "; s=" + this.spalte;
	}
}

interface Spieler {
	public Spielzug naechsterSpielzug(boolean[][] schokolade);
}

class Mensch implements Spieler {
	@Override
	public Spielzug naechsterSpielzug(boolean[][] schokolade) {
		int reihe = IO.readInt("Reihenindex: ");
		int spalte = IO.readInt("Spaltenindex: ");
		return new Spielzug(reihe, spalte);
	}
}

class Computer implements Spieler {
	@Override
	public Spielzug naechsterSpielzug(boolean[][] schokolade) {
		// Strategie: waehle unteres rechtes noch vorhandenes Stuecken
		for (int r = schokolade.length - 1; r >= 0; r--) {
			for (int s = schokolade[0].length - 1; s >= 0; s--) {
				if (schokolade[r][s]) {
					return new Spielzug(r, s);
				}
			}
		}
		return new Spielzug(0, 0); // eigentlich nicht mglich
	}
}
