// gegeben
class Element {

	// Symbol des Elementes
	protected String symbol;

	// Die Ordnungszahl ist die Anzahl der Protonen im Atomkern eines chemischen
	// Elements
	protected int ordnungszahl;

	public Element(String kuerzel, int ordnungszahl) {
		this.symbol = kuerzel;
		this.ordnungszahl = ordnungszahl;
	}

	public String toString() {
		return symbol + "(" + ordnungszahl + ")";
	}
}

// gegeben
public class UE20Aufgabe31 {

	public static void main(String[] args) {
		Element[] elemente = getBeispielElemente();
		java.util.Arrays.sort(elemente);
		for (Element e : elemente) {
			System.out.println(e);
		}
	}

	static Element[] getBeispielElemente() {
		Element[] elemente = new Element[5];
		elemente[0] = new ChemieElement("Ca", 20);
		elemente[1] = new ChemieElement("Mg", 12);
		elemente[2] = new ChemieElement("H", 1);
		elemente[3] = new ChemieElement("O", 8);
		elemente[4] = new ChemieElement("Pd", 46);
		return elemente;
	}
}

// gesucht:
class ChemieElement extends Element implements Comparable<Element> {
	// oder class ChemieElement extends Element implements
	// Comparable<ChemieElement> {

	public ChemieElement(String kuerzel, int ordnungszahl) { // notwendig
		super(kuerzel, ordnungszahl);
	}

	@Override
	public int compareTo(Element o) {
		// oder public int compareTo(ChemieElement o) {
		return ordnungszahl - o.ordnungszahl;
		// Vergleich mit if-Anweisung und R�ckgabe von 1, -1 oder 0 auch ok
	}
}


