import java.awt.Button;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;

public class UE20Aufgabe36 {

	final static int ANZAHL_MULDEN = 12; // > 1
	final static int SAMEN_PRO_MULDE = 3; // > 0

	private int[] brett;
	private int spieler;

	private Button[] muldenButton;
	private Label nachrichtenLabel;

	public static void main(String[] args) {
		new UE20Aufgabe36();
	}

	public UE20Aufgabe36() {
		brett = initBrett();
		spieler = 1;

		JFrame fenster = new JFrame("Sowing");
		fenster.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		fenster.setLayout(new GridLayout(4, 1));
		Label spieler1Label = new Label("Spieler 1: --->");
		fenster.add(spieler1Label);
		Panel buttonPanel = new Panel();
		buttonPanel.setLayout(new GridLayout(1, ANZAHL_MULDEN));
		muldenButton = new Button[ANZAHL_MULDEN];
		for (int i = 0; i < ANZAHL_MULDEN; i++) {
			muldenButton[i] = new Button("" + brett[i]);
			muldenButton[i].addActionListener(new ClickListener(this, i));
			buttonPanel.add(muldenButton[i]);
		}
		fenster.add(buttonPanel);
		Label spieler2Label = new Label("Spieler 2: <---");
		fenster.add(spieler2Label);
		nachrichtenLabel = new Label("Spieler 1 ist am Zug!");
		fenster.add(nachrichtenLabel);
		fenster.pack();
		fenster.setVisible(true);
	}

	int[] initBrett() {
		int[] brett = new int[ANZAHL_MULDEN];
		for (int i = 0; i < brett.length; i++) {
			brett[i] = SAMEN_PRO_MULDE;
		}
		return brett;
	}

	boolean spielEnde() {
		for (int i = 0; i < ANZAHL_MULDEN; i++) {
			if (spielzugOk(i)) {
				return false;
			}
		}
		return true;
	}

	boolean spielzugOk(int mulde) {
		if (spieler == 1) {
			return mulde >= 0 && mulde < ANZAHL_MULDEN && brett[mulde] > 0
					&& mulde + brett[mulde] < ANZAHL_MULDEN
					&& brett[mulde + brett[mulde]] > 0;
		} else {
			return mulde >= 0 && mulde < ANZAHL_MULDEN && brett[mulde] > 0
					&& mulde - brett[mulde] >= 0
					&& brett[mulde - brett[mulde]] > 0;
		}
	}

	void spielzugAusfuehren(int mulde) {
		if (spieler == 1) {
			for (int i = 1; i <= brett[mulde]; i++) {
				brett[mulde + i]++;
				muldenButton[mulde + i].setLabel("" + brett[mulde + i]);
			}
		} else {
			for (int i = 1; i <= brett[mulde]; i++) {
				brett[mulde - i]++;
				muldenButton[mulde - i].setLabel("" + brett[mulde - i]);
			}
		}
		brett[mulde] = 0;
		muldenButton[mulde].setLabel("" + brett[mulde]);
	}

	public void click(int mulde) {
		if (!spielzugOk(mulde)) {
			nachrichtenLabel.setText("Spieler " + spieler
					+ ": Ungueltig! Bitte gueltigen Spielzug eingeben!");
		} else {
			spielzugAusfuehren(mulde);
			spieler = spieler % 2 + 1; // Spielerwechsel
			if (spielEnde()) {
				nachrichtenLabel.setText("Spieler " + spieler
						+ " hat verloren!");
				for (int i = 0; i < ANZAHL_MULDEN; i++) {
					muldenButton[i].setEnabled(false);
				}
			} else {
				nachrichtenLabel.setText("Spieler " + spieler + " ist am Zug!");
			}
		}
	}

}

class ClickListener implements ActionListener {

	private UE20Aufgabe36 spiel;
	private int mulde;

	ClickListener(UE20Aufgabe36 spiel, int mulde) {
		this.spiel = spiel;
		this.mulde = mulde;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		spiel.click(mulde);
	}

}
