interface Behaelter {
	public double getOberflaeche();

	public double getVolumen();

	public void veraendern(double inkrement);
}

class Wuerfel implements Behaelter {
	private double kantenLaenge;

	public Wuerfel(double kantenLaenge) {
		this.kantenLaenge = kantenLaenge;
	}

	public double getOberflaeche() {
		return 6.0 * this.kantenLaenge * this.kantenLaenge;
	}

	public double getVolumen() {
		return this.kantenLaenge * this.kantenLaenge * this.kantenLaenge;
	}

	public void veraendern(double inkrement) {
		this.kantenLaenge += inkrement;
	}
}

class Kugel implements Behaelter {
	static final double PI = 3.1415;
	private double radius;

	public Kugel(double radius) {
		this.radius = radius;
	}

	public double getOberflaeche() {
		return 4.0 * PI * this.radius * this.radius;
	}

	public double getVolumen() {
		return 4.0 / 3.0 * PI * this.radius * this.radius * this.radius;
	}

	public void veraendern(double inkrement) {
		this.radius += inkrement;
	}
}

public class UE20Aufgabe7 {

	public static void main(String[] args) {

		// Eingabe und Erzeugung
		double kante = 0.0;
		while (true) {
			kante = IO.readDouble("Kantenlaenge: ");
			if (kante > 0.0)
				break;
			IO.println("fehlerhafte Eingabe (>0 erwartet)");
		}
		Wuerfel wuerfel = new Wuerfel(kante);

		double radius = 0.0;
		while (true) {
			radius = IO.readDouble("Radius: ");
			if (radius > 0.0)
				break;
			IO.println("fehlerhafte Eingabe (>0 erwartet)");
		}
		Kugel kugel = new Kugel(radius);

		IO.println("Wuerfel-Volumen (Anfang): " + wuerfel.getVolumen());
		IO.println("Kugel-Volumen (Anfang): " + kugel.getVolumen());

		double inkrement = 0.0;
		while (true) {
			inkrement = IO.readDouble("Inkrement: ");
			if (inkrement > 0.0)
				break;
			IO.println("fehlerhafte Eingabe (>0 erwartet)");
		}

		// Simulation
		Behaelter cGross = null;
		Behaelter cKlein = null;
		if (wuerfel.getVolumen() > kugel.getVolumen()) {
			cGross = wuerfel;
			cKlein = kugel;
		} else {
			cGross = kugel;
			cKlein = wuerfel;
		}
		while (cGross.getVolumen() > cKlein.getVolumen()) {
			cGross.veraendern(-inkrement);
			cKlein.veraendern(inkrement);
		}

		// Ausgabe
		IO.println("Wuerfel-Volumen: " + wuerfel.getVolumen());
		IO.println("Wuerfel-Oberflaeche: " + wuerfel.getOberflaeche());
		IO.println("Kugel-Volumen: " + kugel.getVolumen());
		IO.println("Kugel-Oberflaeche: " + kugel.getOberflaeche());
	}
}